# coding: utf-8
from utg.relations import *
from utg import data
from utg import logic

# receive and return only serialized data
def migrate(word_data):

    if word_data['type'] == 3: # verb
        migrate_forms(word_data, OLD_VERB_CACHE, data.WORDS_CACHES[WORD_TYPE.VERB])

    return word_data


def migrate_forms(word_data, old_cache, new_cache):
    old_forms = word_data['forms']
    new_forms = [''] * len(new_cache)

    for new_key, new_index in new_cache.items():
        new_forms[new_index] = old_forms[get_nearest_old_index(new_key, old_cache)]

    word_data['forms'] = new_forms


def get_nearest_old_index(new_key, old_cache):
    old_key = logic.get_nearest_key(new_key, list(old_cache.keys()))
    return old_cache[old_key]


OLD_VERB_CACHE = {(VERB_FORM.CONDITIONAL, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 32, (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 7, (VERB_FORM.IMPERATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 27, (VERB_FORM.CONDITIONAL, TIME.PAST, NUMBER.PLURAL, None, None): 11, (VERB_FORM.IMPERATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 30, (VERB_FORM.IMPERATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.FIRST, None): 16, (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 22, (VERB_FORM.IMPERATIVE, TIME.PAST, NUMBER.PLURAL, None, None): 12, (VERB_FORM.IMPERATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 33, (VERB_FORM.IMPERATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.THIRD, None): 15, (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 19, (VERB_FORM.IMPERATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.FIRST, None): 13, (VERB_FORM.CONDITIONAL, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 2, (VERB_FORM.CONDITIONAL, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 29, (VERB_FORM.CONDITIONAL, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 5, (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.PLURAL, None, None): 10, (VERB_FORM.IMPERATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 36, (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 25, (VERB_FORM.CONDITIONAL, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 20, (VERB_FORM.IMPERATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.THIRD, None): 18, (VERB_FORM.IMPERATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 3, (VERB_FORM.CONDITIONAL, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 8, (VERB_FORM.INFINITIVE, None, None, None, None): 0, (VERB_FORM.IMPERATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 24, (VERB_FORM.IMPERATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.SECOND, None): 14, (VERB_FORM.CONDITIONAL, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 35, (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 28, (VERB_FORM.IMPERATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 21, (VERB_FORM.IMPERATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 6, (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 31, (VERB_FORM.IMPERATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.SECOND, None): 17, (VERB_FORM.CONDITIONAL, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 26, (VERB_FORM.CONDITIONAL, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 23, (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 1, (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 34, (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 4, (VERB_FORM.IMPERATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 9}
