# coding: utf-8

from utg.relations import *
from utg import logic

# receive and return only serialized data
def migrate(word_data):
    word_type = WORD_TYPE(word_data['type'])
    return migrate_forms(word_data, OLD_CACHES[word_type], NEW_CACHES[word_type])


def migrate_forms(word_data, old_cache, new_cache):
    old_forms = word_data['forms']
    new_forms = [''] * len(new_cache)

    for new_key, new_index in new_cache.items():
        new_forms[new_index] = old_forms[get_nearest_old_index(new_key, old_cache)]

    word_data['forms'] = new_forms

    return word_data


def get_nearest_old_index(new_key, old_cache):
    old_key = logic.get_nearest_key(new_key, list(old_cache.keys()))
    return old_cache[old_key]


OLD_CACHES = {WORD_TYPE.NOUN: {(NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.NOMINATIVE): 0,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.GENITIVE): 1,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.DATIVE): 2,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.ACCUSATIVE): 3,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.INSTRUMENTAL): 4,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.PREPOSITIONAL): 5,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.NOMINATIVE): 6,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.GENITIVE): 7,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.DATIVE): 8,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.ACCUSATIVE): 9,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.INSTRUMENTAL): 10,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.PREPOSITIONAL): 11,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.NOMINATIVE): 12,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.GENITIVE): 13,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.DATIVE): 14,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.ACCUSATIVE): 15,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.INSTRUMENTAL): 16,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.PREPOSITIONAL): 17},
 WORD_TYPE.ADJECTIVE:{(ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 0,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 3,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 6,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 9,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 12,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 15,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 18,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 21,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 24,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 27,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 30,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 33,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 36,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 39,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 42,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 45,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 48,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 51,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 54,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 57,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 60,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 63,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 66,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 69,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 72,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 75,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 78,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 81,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 84,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 87,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 90,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 93,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 96,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 99,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 102,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 105,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 108,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 111,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 114,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 117,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 120,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 123,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 126,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 129,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 132,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 135,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 138,
 (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 141,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 1,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 4,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 7,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 10,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 13,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 16,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 19,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 22,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 25,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 28,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 31,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 34,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 37,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 40,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 43,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 46,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 49,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 52,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 55,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 58,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 61,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 64,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 67,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 70,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 73,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 76,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 79,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 82,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 85,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 88,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 91,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 94,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 97,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 100,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 103,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 106,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 109,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 112,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 115,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 118,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 121,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 124,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 127,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 130,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 133,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 136,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 139,
 (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 142,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 2,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 5,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 8,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 11,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 14,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 17,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 20,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 23,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 26,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 29,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 32,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 35,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 38,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 41,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 44,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 47,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 50,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 53,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 56,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 59,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 62,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 65,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 68,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 71,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 74,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 77,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 80,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 83,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 86,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 89,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 92,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 95,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 98,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 101,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 104,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 107,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 110,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 113,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 116,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 119,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 122,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 125,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 128,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 131,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 134,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 137,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 140,
 (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 143,
 (ADJECTIVE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.MASCULINE, None): 144,
 (ADJECTIVE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.NEUTER, None): 145,
 (ADJECTIVE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.FEMININE, None): 146,
 (ADJECTIVE_FORM.SHORT, None, NUMBER.PLURAL, None, None, None): 147},
 WORD_TYPE.PRONOUN: {(NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.MASCULINE): 0,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.NEUTER): 1,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.FEMININE): 2,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.MASCULINE): 3,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.NEUTER): 4,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.FEMININE): 5,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.MASCULINE): 6,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.NEUTER): 7,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.FEMININE): 8,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.MASCULINE): 9,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.NEUTER): 10,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.FEMININE): 11,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.MASCULINE): 12,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.NEUTER): 13,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.FEMININE): 14,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.MASCULINE): 15,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.NEUTER): 16,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.FEMININE): 17,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.MASCULINE): 18,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.NEUTER): 19,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.FEMININE): 20,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.MASCULINE): 21,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.NEUTER): 22,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.FEMININE): 23,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.MASCULINE): 24,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.NEUTER): 25,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.FEMININE): 26,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.MASCULINE): 27,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.NEUTER): 28,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.FEMININE): 29,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.MASCULINE): 30,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.NEUTER): 31,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.FEMININE): 32,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.MASCULINE): 33,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.NEUTER): 34,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.FEMININE): 35,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.MASCULINE): 36,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.NEUTER): 37,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.FEMININE): 38,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.MASCULINE): 39,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.NEUTER): 40,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.FEMININE): 41,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.MASCULINE): 42,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.NEUTER): 43,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.FEMININE): 44,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.MASCULINE): 45,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.NEUTER): 46,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.FEMININE): 47,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.MASCULINE): 48,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.NEUTER): 49,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.FEMININE): 50,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.MASCULINE): 51,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.NEUTER): 52,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.FEMININE): 53,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.FIRST, None): 54,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.SECOND, None): 55,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.THIRD, None): 56,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.FIRST, None): 57,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.SECOND, None): 58,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.THIRD, None): 59,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.FIRST, None): 60,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.SECOND, None): 61,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.THIRD, None): 62,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.FIRST, None): 63,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.SECOND, None): 64,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.THIRD, None): 65,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.FIRST, None): 66,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.SECOND, None): 67,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.THIRD, None): 68,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.FIRST, None): 69,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.SECOND, None): 70,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.THIRD, None): 71},
 WORD_TYPE.VERB: {(VERB_FORM.INFINITIVE, None, None, None, None): 0,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 1,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 2,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 3,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.PLURAL, None, None): 4,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.FIRST, None): 5,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.SECOND, None): 6,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.THIRD, None): 7,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.FIRST, None): 8,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.SECOND, None): 9,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.THIRD, None): 10,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 11,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 12,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 13,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 14,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 15,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 16,
                  # (VERB_FORM.CONDITIONAL, None, NUMBER.SINGULAR, None, GENDER.MASCULINE): 17,
                  # (VERB_FORM.CONDITIONAL, None, NUMBER.SINGULAR, None, GENDER.NEUTER): 18,
                  # (VERB_FORM.CONDITIONAL, None, NUMBER.SINGULAR, None, GENDER.FEMININE): 19,
                  # (VERB_FORM.CONDITIONAL, None, NUMBER.PLURAL, None, None): 20,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.FIRST, None): 21,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.SECOND, None): 22,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.THIRD, None): 23,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.FIRST, None): 24,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.SECOND, None): 25,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.THIRD, None): 26},
 WORD_TYPE.PARTICIPLE: {(PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 0,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 1,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 2,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 3,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 4,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 5,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 6,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 7,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 8,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 9,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 10,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 11,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 12,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 13,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 14,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 15,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 16,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 17,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 18,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 19,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 20,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 21,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 22,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 23,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 24,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 25,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 26,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 27,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 28,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 29,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 30,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 31,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 32,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 33,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 34,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 35,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 36,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 37,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 38,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 39,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 40,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 41,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 42,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 43,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 44,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 45,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 46,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 47,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 48,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 49,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 50,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 51,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 52,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 53,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 54,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 55,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 56,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 57,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 58,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 59,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 60,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 61,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 62,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 63,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 64,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 65,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 66,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 67,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 68,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 69,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 70,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 71,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 72,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 73,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 74,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 75,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 76,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 77,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 78,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 79,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 80,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 81,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 82,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 83,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 84,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 85,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 86,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 87,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 88,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 89,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 90,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 91,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 92,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 93,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 94,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 95,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 96,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 97,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 98,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 99,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 100,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 101,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 102,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 103,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 104,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 105,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 106,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 107,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 108,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 109,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 110,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 111,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 112,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 113,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 114,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 115,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 116,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 117,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 118,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 119,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 120,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 121,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 122,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 123,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 124,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 125,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 126,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 127,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 128,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 129,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 130,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 131,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 132,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 133,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 134,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 135,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 136,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 137,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 138,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 139,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 140,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 141,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 142,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 143,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 144,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 145,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 146,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 147,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 148,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 149,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 150,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 151,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 152,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 153,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 154,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 155,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 156,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 157,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 158,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 159,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 160,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 161,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 162,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 163,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 164,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 165,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 166,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 167,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 168,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 169,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 170,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 171,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 172,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 173,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 174,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 175,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 176,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 177,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 178,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 179,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 180,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 181,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 182,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 183,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 184,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 185,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 186,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 187,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 188,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 189,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 190,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 191,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 192,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 193,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 194,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 195,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 196,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 197,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 198,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 199,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 200,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 201,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 202,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 203,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 204,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 205,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 206,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 207,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 208,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 209,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 210,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 211,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 212,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 213,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 214,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 215,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 216,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 217,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 218,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 219,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 220,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 221,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 222,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 223,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 224,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 225,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 226,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 227,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 228,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 229,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 230,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 231,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 232,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 233,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 234,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 235,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 236,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 237,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 238,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 239,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 240,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 241,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 242,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 243,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 244,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 245,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 246,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 247,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 248,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 249,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 250,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 251,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 252,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 253,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 254,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 255,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 256,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 257,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 258,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 259,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 260,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 261,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 262,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 263,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 264,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 265,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 266,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 267,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 268,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 269,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 270,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 271,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 272,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 273,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 274,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 275,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 276,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 277,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 278,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 279,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 280,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 281,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 282,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 283,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 284,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 285,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 286,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 287,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.MASCULINE, None): 288,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.NEUTER, None): 289,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.FEMININE, None): 290,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.PLURAL, None, None, None): 291},
 WORD_TYPE.INTEGER: {(): 0},
 WORD_TYPE.TEXT: {(): 0},
 WORD_TYPE.PREPOSITION: {(PREPOSITION_FORM.NORMAL,): 0,
                         (PREPOSITION_FORM.ALTERNATIVE,): 1,
                         (PREPOSITION_FORM.SPECIAL,): 2}}

NEW_CACHES = {WORD_TYPE.NOUN: {(NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.NOMINATIVE): 0,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.GENITIVE): 1,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.DATIVE): 2,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.ACCUSATIVE): 3,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.INSTRUMENTAL): 4,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.PREPOSITIONAL): 5,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.NOMINATIVE): 6,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.GENITIVE): 7,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.DATIVE): 8,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.ACCUSATIVE): 9,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.INSTRUMENTAL): 10,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.PREPOSITIONAL): 11,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.NOMINATIVE): 12,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.GENITIVE): 13,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.DATIVE): 14,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.ACCUSATIVE): 15,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.INSTRUMENTAL): 16,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.PREPOSITIONAL): 17},
 WORD_TYPE.ADJECTIVE: {(ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 0,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 1,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 2,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 3,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 4,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 5,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 6,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 7,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 8,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 9,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 10,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 11,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 12,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 13,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 14,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 15,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 16,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 17,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 18,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 19,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 20,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 21,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 22,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 23,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 24,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 25,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 26,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 27,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 28,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 29,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 30,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 31,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 32,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 33,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 34,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 35,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 36,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 37,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 38,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 39,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 40,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 41,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 42,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 43,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 44,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 45,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 46,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 47,
                       (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, None, None, None, None): 48,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 49,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 50,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 51,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 52,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 53,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 54,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 55,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 56,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 57,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 58,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 59,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 60,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 61,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 62,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 63,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 64,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 65,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 66,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 67,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 68,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 69,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 70,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 71,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 72,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 73,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 74,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 75,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 76,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 77,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 78,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 79,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 80,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 81,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 82,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 83,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 84,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 85,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 86,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 87,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 88,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 89,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 90,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 91,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 92,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 93,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 94,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 95,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 96,
                       (ADJECTIVE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.MASCULINE, None): 97,
                       (ADJECTIVE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.NEUTER, None): 98,
                       (ADJECTIVE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.FEMININE, None): 99,
                       (ADJECTIVE_FORM.SHORT, None, NUMBER.PLURAL, None, None, None): 100},
 WORD_TYPE.PRONOUN: {(NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.MASCULINE): 0,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.NEUTER): 1,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.FEMININE): 2,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.MASCULINE): 3,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.NEUTER): 4,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.FEMININE): 5,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.MASCULINE): 6,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.NEUTER): 7,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.FEMININE): 8,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.MASCULINE): 9,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.NEUTER): 10,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.FEMININE): 11,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.MASCULINE): 12,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.NEUTER): 13,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.FEMININE): 14,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.MASCULINE): 15,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.NEUTER): 16,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.FEMININE): 17,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.MASCULINE): 18,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.NEUTER): 19,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.FEMININE): 20,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.MASCULINE): 21,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.NEUTER): 22,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.FEMININE): 23,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.MASCULINE): 24,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.NEUTER): 25,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.FEMININE): 26,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.MASCULINE): 27,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.NEUTER): 28,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.FEMININE): 29,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.MASCULINE): 30,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.NEUTER): 31,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.FEMININE): 32,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.MASCULINE): 33,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.NEUTER): 34,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.FEMININE): 35,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.MASCULINE): 36,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.NEUTER): 37,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.FEMININE): 38,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.MASCULINE): 39,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.NEUTER): 40,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.FEMININE): 41,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.MASCULINE): 42,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.NEUTER): 43,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.FEMININE): 44,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.MASCULINE): 45,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.NEUTER): 46,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.FEMININE): 47,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.MASCULINE): 48,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.NEUTER): 49,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.FEMININE): 50,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.MASCULINE): 51,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.NEUTER): 52,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.FEMININE): 53,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.FIRST, None): 54,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.SECOND, None): 55,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.THIRD, None): 56,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.FIRST, None): 57,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.SECOND, None): 58,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.THIRD, None): 59,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.FIRST, None): 60,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.SECOND, None): 61,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.THIRD, None): 62,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.FIRST, None): 63,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.SECOND, None): 64,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.THIRD, None): 65,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.FIRST, None): 66,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.SECOND, None): 67,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.THIRD, None): 68,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.FIRST, None): 69,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.SECOND, None): 70,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.THIRD, None): 71},
 WORD_TYPE.VERB: {(VERB_FORM.INFINITIVE, None, None, None, None): 0,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 1,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 2,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 3,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.PLURAL, None, None): 4,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.FIRST, None): 5,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.SECOND, None): 6,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.THIRD, None): 7,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.FIRST, None): 8,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.SECOND, None): 9,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.THIRD, None): 10,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 11,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 12,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 13,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 14,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 15,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 16,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.SECOND, None): 17,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.FIRST, None): 18,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.SECOND, None): 19},
 WORD_TYPE.PARTICIPLE: {(PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 0,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 1,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 2,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 3,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 4,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 5,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 6,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 7,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 8,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 9,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 10,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 11,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 12,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 13,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 14,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 15,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 16,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 17,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 18,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 19,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 20,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 21,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 22,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 23,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 24,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 25,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 26,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 27,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 28,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 29,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 30,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 31,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 32,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 33,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 34,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 35,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 36,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 37,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 38,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 39,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 40,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 41,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 42,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 43,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 44,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 45,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 46,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 47,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 48,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 49,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 50,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 51,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 52,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 53,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 54,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 55,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 56,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 57,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 58,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 59,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 60,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 61,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 62,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 63,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 64,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 65,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 66,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 67,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 68,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 69,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 70,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 71,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 72,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 73,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 74,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 75,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 76,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 77,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 78,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 79,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 80,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 81,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 82,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 83,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 84,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 85,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 86,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 87,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 88,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 89,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 90,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 91,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 92,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 93,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 94,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 95,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 96,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 97,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 98,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 99,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 100,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 101,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 102,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 103,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 104,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 105,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 106,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 107,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 108,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 109,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 110,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 111,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 112,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 113,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 114,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 115,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 116,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 117,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 118,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 119,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 120,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 121,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 122,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 123,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 124,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 125,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 126,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 127,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 128,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 129,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 130,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 131,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 132,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 133,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 134,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 135,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 136,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 137,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 138,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 139,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 140,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 141,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 142,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 143,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.MASCULINE, None): 144,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.NEUTER, None): 145,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.SINGULAR, None, GENDER.FEMININE, None): 146,
                        (PARTICIPLE_FORM.SHORT, None, NUMBER.PLURAL, None, None, None): 147},
 WORD_TYPE.INTEGER: {(): 0},
 WORD_TYPE.TEXT: {(): 0},
 WORD_TYPE.PREPOSITION: {(PREPOSITION_FORM.NORMAL,): 0,
                         (PREPOSITION_FORM.ALTERNATIVE,): 1,
                         (PREPOSITION_FORM.SPECIAL,): 2}}
